export default class BrowserRequest {

    static async get(url, data = null, headers = null) {
        return this._request("GET", url, data, headers);
    }

    static async post(url, data = null, headers = null) {
        return this._request("POST", url, data, headers);
    }

    static async put(url, data = null, headers = null) {
        return this._request("PUT", url, data, headers);
    }

    static async delete(url, data = null, headers = null) {
        return this._request("DELETE", url, data, headers);
    }

    static async patch(url, data = null, headers = null) {
        return this._request("PATCH", url, data, headers);
    }

    static async _request(method, url, data = null, headers = null) {
        const completeHeaders = {
            ...{ "Content-Type": "application/json" }, ...headers
        }
        const options = { method: method, headers: completeHeaders }
        if (data) options.body = JSON.stringify(Object.fromEntries(data));

        const res = await fetch(url, options);
        return res.json();
    }


}